#include "ehs/Types.h"

extern "C"
{
	// Mock ffi_type structure
	struct ffi_type
	{
		ehs::UInt_64 size;
		unsigned short alignment;
		unsigned short type;
		struct ffi_type** elements;
	};

	// Mock ffi_status enum
	typedef enum
	{
		FFI_OK,
		FFI_BAD_TYPEDEF,
		FFI_BAD_ABI
	} ffi_status;

	// Declare the ffi_type variables as extern if they are defined elsewhere or just define them if they are used locally
	struct ffi_type ffi_type_void = {0, 0, 0, nullptr};
	struct ffi_type ffi_type_pointer = {sizeof(void*), __alignof__(void*), 0, nullptr};
	struct ffi_type ffi_type_uint32 = {sizeof(unsigned int), __alignof__(unsigned int), 0, nullptr};
	struct ffi_type ffi_type_sint32 = {sizeof(int), __alignof__(int), 0, nullptr};

	// Mock ffi_prep_cif function
	ffi_status ffi_prep_cif(void* cif, int abi, unsigned int nargs, struct ffi_type* rtype, struct ffi_type** atypes)
	{
		return FFI_OK; // Pretend success
	}

	// Mock ffi_call function
	void ffi_call(void* cif, void (* fn)(), void* rvalue, void** avalues)
	{
		// Do nothing
	}

	__asm__(".symver ffi_type_void,ffi_type_void@LIBFFI_BASE_8.0");
	__asm__(".symver ffi_type_pointer,ffi_type_pointer@LIBFFI_BASE_8.0");
	__asm__(".symver ffi_type_uint32,ffi_type_uint32@LIBFFI_BASE_8.0");
	__asm__(".symver ffi_type_sint32,ffi_type_sint32@LIBFFI_BASE_8.0");
	__asm__(".symver ffi_prep_cif,ffi_prep_cif@LIBFFI_BASE_8.0");
	__asm__(".symver ffi_call,ffi_call@LIBFFI_BASE_8.0");
}